libzypp: zypp::sat::Solvable Class Reference

libzypp 17.36.6

Classes | Public Types | Public Member Functions | Static Public Member Functions | Static Public Attributes | Related Symbols | List of all members
zypp::sat::Solvable Class Reference

A Solvable object within the sat Pool. More...

`#include <zypp/sat/Solvable.h>`

Inheritance diagram for zypp::sat::Solvable:

## Classes
class | SplitIdent
| Helper that splits an identifier into kind and name or vice versa. More...

## Public Types
using | IdType = sat::detail::SolvableIdType

## Public Member Functions
| Solvable ()
| Default ctor creates noSolvable.
| Solvable (const Solvable &)=default
| Solvable (Solvable &&) noexcept=default
Solvable & | operator= (const Solvable &)=default
Solvable & | operator= (Solvable &&) noexcept=default
| Solvable (IdType id_r)
| PoolImpl ctor.
| operator bool () const
| Evaluate Solvable in a boolean context (`!=` `noSolvable`).
IdString | ident () const
| The identifier.
ResKind | kind () const
| The Solvables ResKind.
bool | isKind (const ResKind &kind_r) const
| Test whether a Solvable is of a certain ResKind.
template<class TRes>
bool | isKind () const
| This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.
template<class TIterator>
bool | isKind (TIterator begin, TIterator end) const
std::string | name () const
| The name (without any ResKind prefix).
Edition | edition () const
| The edition (version-release).
Arch | arch () const
| The architecture.
IdString | vendor () const
| The vendor.
Repository | repository () const
| The Repository this Solvable belongs to.
RepoInfo | repoInfo () const
| The repositories RepoInfo.
bool | isSystem () const
| Return whether this Solvable belongs to the system repo.
bool | onSystemByUser () const
| Whether this is known to be installed on behalf of a user request.
bool | onSystemByAuto () const
| Whether this is known to be automatically installed (as dependency of a user request package).
bool | identIsAutoInstalled () const
| Whether an installed solvable with the same ident is flagged as AutoInstalled.
bool | multiversionInstall () const
| Whether different versions of this package can be installed at the same time.
bool | isNeedreboot () const
| Whether this solvable triggers the reboot-needed hint if installed/updated.
Blacklisted packages.
Blacklisted packages are visible in a repository, but no matter how good they apparently look like, they must not be considered during normal operations. Under normal conditions the resolver will avoid selecting blacklisted packages. To install a blacklisted package it must be selected explicitly. Whether this is a good idea, depends on the reason for having been blacklisted: RETRACTED packages are usually buggy packages/patches which have been released and can not be removed from the public repositories anymore. Nevertheless those packages should not be installed. PTFs usually contain special features or fixes which are not yet released as an official patch upadate. Installing a PTF will prevent its packages from being updated until you decide to remove the PTF and follow the official releases again.
bool | isBlacklisted () const
| Whether this solvable is blacklisted (retracted,ptf,...).
bool | isRetracted () const
| Whether this solvable is retracted (provides retractedToken).
bool | isPtf () const
| Whether this solvable belongs to a PTF (provides ptfMasterToken or ptfPackageToken).
bool | isPtfMaster () const
| Subset of isPtf (provides ptfMasterToken).
bool | isPtfPackage () const
| Subset of isPtf (provides ptfPackageToken).
Date | buildtime () const
| The items build time.
Date | installtime () const
| The items install time (`false` if not installed).
std::string | asString () const
| String representation `"ident-edition.arch"` or `"noSolvable"`.
std::string | asUserString () const
| String representation `"ident-edition.arch(repo)"` or `"noSolvable"`.
bool | identical (const Solvable &rhs) const
| Test whether two Solvables have the same content.
bool | sameNVRA (const Solvable &rhs) const
| Test for same name-version-release.arch.
Locale support.
bool | supportsLocales () const
| Whether this `Solvable` claims to support locales.
bool | supportsLocale (const Locale &locale_r) const
| Whether this `Solvable` supports a specific Locale.
bool | supportsLocale (const LocaleSet &locales_r) const
| Whether this `Solvable` supports at least one of the specified locales.
bool | supportsRequestedLocales () const
| Whether this `Solvable` supports at least one requested locale.
LocaleSet | getSupportedLocales () const
| Return the supported locales.
void | getSupportedLocales (LocaleSet &locales_r) const
CpeId | cpeId () const
| The solvables CpeId if available.
unsigned | mediaNr () const
| Media number the solvable is located on (`0` if no media access required).
ByteCount | installSize () const
| Installed (unpacked) size.
ByteCount | downloadSize () const
| Download size.
std::string | distribution () const
| The distribution string.
std::string | summary (const Locale &lang_r=Locale()) const
| Short (singleline) text describing the solvable (opt.
std::string | description (const Locale &lang_r=Locale()) const
| Long (multiline) text describing the solvable (opt.
std::string | insnotify (const Locale &lang_r=Locale()) const
| UI hint text when selecting the solvable for install (opt.
std::string | delnotify (const Locale &lang_r=Locale()) const
| UI hint text when selecting the solvable for uninstall (opt.
std::string | licenseToConfirm (const Locale &lang_r=Locale()) const
| License or agreement to accept before installing the solvable (opt.
bool | needToAcceptLicense () const
| `True` except for well known exceptions (i.e show license but no need to accept it).

## Static Public Member Functions
static bool | identIsAutoInstalled (const IdString &ident_r)

## Static Public Attributes
static const IdString | retractedToken { "retracted-patch-package()" }
| Indicator provides `retracted-patch-package()`
static const IdString | ptfMasterToken { "ptf()" }
| Indicator provides `ptf()`
static const IdString | ptfPackageToken { "ptf-package()" }
| Indicator provides `ptf-package()`
static const Solvable | noSolvable
| Represents no Solvable.

## Related Symbols
(Note that these are not member symbols.)
std::ostream & | operator<< (std::ostream &str, const Solvable &obj) ZYPP_API
| Stream output.
std::ostream & | dumpOn (std::ostream &str, const Solvable &obj) ZYPP_API
| More verbose stream output including dependencies.
std::ostream & | dumpAsXmlOn (std::ostream &str, const Solvable &obj) ZYPP_API
| XML output.
bool | operator== (const Solvable &lhs, const Solvable &rhs)
bool | operator!= (const Solvable &lhs, const Solvable &rhs)
bool | operator< (const Solvable &lhs, const Solvable &rhs)
template<class TRes>
bool | isKind (const Solvable &solvable_r)
| Test whether a Solvable is of a certain Kind.
bool | identical (const Solvable &lhs, const Solvable &rhs)
| Test for same content.
bool | sameNVRA (const Solvable &lhs, const Solvable &rhs)
| Test for same name version release and arch.
int | compareByN (const Solvable &lhs, const Solvable &rhs)
| Compare according to kind and name.
int | compareByNVR (const Solvable &lhs, const Solvable &rhs)
| Compare according to kind, name and edition.
int | compareByNVRA (const Solvable &lhs, const Solvable &rhs)
| Compare according to kind, name, edition and arch.

## Access to the \ref Solvable dependencies.
Note Prerequires are a subset of requires.
Capabilities const | ZYPP_DEPRECATED
Capabilities | dep_provides () const
Capabilities | dep_requires () const
Capabilities | dep_conflicts () const
Capabilities | dep_obsoletes () const
Capabilities | dep_recommends () const
Capabilities | dep_suggests () const
Capabilities | dep_enhances () const
Capabilities | dep_supplements () const
Capabilities | dep_prerequires () const
Capabilities | provides () const ZYPP_DEPRECATED
Capabilities | conflicts () const ZYPP_DEPRECATED
Capabilities | obsoletes () const ZYPP_DEPRECATED
Capabilities | recommends () const ZYPP_DEPRECATED
Capabilities | suggests () const ZYPP_DEPRECATED
Capabilities | enhances () const ZYPP_DEPRECATED
Capabilities | supplements () const ZYPP_DEPRECATED
Capabilities | prerequires () const ZYPP_DEPRECATED
Capabilities | dep (Dep which_r) const
| Return Capabilities selected by Dep constant.
Capabilities | operator[] (Dep which_r) const
CapabilitySet | providesNamespace (const std::string &namespace_r) const
| Return the namespaced provides `'namespace([value])[ op edition]'` of this Solvable.
CapabilitySet | valuesOfNamespace (const std::string &namespace_r) const
| Return `'value[ op edition]'` for namespaced provides `'namespace(value)[ op edition]'`.
std::pair< bool, CapabilitySet > | matchesSolvable (const SolvAttr &attr, const sat::Solvable &solv) const

## Attribute lookup.
See also LookupAttr and ArrayAttr providing a general, more query like interface for attribute retrieval.
IdType | _id
std::string | lookupStrAttribute (const SolvAttr &attr) const
| returns the string attribute value for attr or an empty string if it does not exists.
std::string | lookupStrAttribute (const SolvAttr &attr, const Locale &lang_r) const
unsigned long long | lookupNumAttribute (const SolvAttr &attr) const
| returns the numeric attribute value for attr or 0 if it does not exists.
unsigned long long | lookupNumAttribute (const SolvAttr &attr, unsigned long long notfound_r) const
bool | lookupBoolAttribute (const SolvAttr &attr) const
| returns the boolean attribute value for attr or `false` if it does not exists.
detail::IdType | lookupIdAttribute (const SolvAttr &attr) const
| returns the id attribute value for attr or detail::noId if it does not exists.
CheckSum | lookupCheckSumAttribute (const SolvAttr &attr) const
| returns the CheckSum attribute value for attr or an empty CheckSum if ir does not exist.
OnMediaLocation | lookupLocation () const
| returns OnMediaLocation data: This is everything we need to download e.g.
Solvable | nextInPool () const
| Return next Solvable in Pool (or noSolvable).
Solvable | nextInRepo () const
| Return next Solvable in Repo (or noSolvable).
detail::CSolvable * | get () const
| Expert backdoor.
IdType | id () const
| Expert backdoor.

## Additional Inherited Members
Static Protected Member Functions inherited from zypp::sat::detail::PoolMember
static PoolImpl & | myPool ()

## Detailed Description

A Solvable object within the sat Pool.

Note
  Unfortunately libsolv combines the objects kind and name in a single identifier `"pattern:kde_multimedia"`, except for packages and source packes. They are not prefixed by any kind string. Instead the architecture is abused to store `"src"` and `"nosrc"` values.

Solvable will hide this inconsistency by treating source packages as an own kind of solvable and map their arch to Arch_noarch.

Definition at line 53 of file Solvable.h.

## Member Typedef Documentation

## ◆ IdType

using zypp::sat::Solvable::IdType = sat::detail::SolvableIdType

Definition at line 56 of file Solvable.h.

## Constructor & Destructor Documentation

## ◆ Solvable() [1/4]

zypp::sat::Solvable::Solvable | ( |  | ) |
| inline

Default ctor creates noSolvable.

Definition at line 64 of file Solvable.h.

## ◆ Solvable() [2/4]

zypp::sat::Solvable::Solvable | ( | const Solvable & |  | ) |
| default

## ◆ Solvable() [3/4]

zypp::sat::Solvable::Solvable | ( | Solvable && |  | ) |
| defaultnoexcept

## ◆ Solvable() [4/4]

zypp::sat::Solvable::Solvable | ( | IdType | id_r | ) |
| inlineexplicit

PoolImpl ctor.

Definition at line 74 of file Solvable.h.

## Member Function Documentation

## ◆ operator=() [1/2]

Solvable & zypp::sat::Solvable::operator= | ( | const Solvable & |  | ) |
| default

## ◆ operator=() [2/2]

Solvable & zypp::sat::Solvable::operator= | ( | Solvable && |  | ) |
| defaultnoexcept

## ◆ operator bool()

zypp::sat::Solvable::operator bool | ( |  | ) | const
| inlineexplicit

Evaluate Solvable in a boolean context (`!=` `noSolvable`).

Definition at line 83 of file Solvable.h.

## ◆ ident()

IdString zypp::sat::Solvable::ident | ( |  | ) | const

The identifier.

This is the solvables name, except for packages and source packes, prefixed by its kind.

Definition at line 270 of file Solvable.cc.

## ◆ kind()

ResKind zypp::sat::Solvable::kind | ( |  | ) | const

The Solvables ResKind.

Definition at line 276 of file Solvable.cc.

## ◆ isKind() [1/3]

bool zypp::sat::Solvable::isKind | ( | const ResKind & | kind_r | ) | const

Test whether a Solvable is of a certain ResKind.

The test is far cheaper than actually retrieving and comparing the kind.

Definition at line 303 of file Solvable.cc.

## ◆ isKind() [2/3]

template<class TRes>

bool zypp::sat::Solvable::isKind | ( |  | ) | const
| inline

This is an overloaded member function, provided for convenience. It differs from the above function only in what argument(s) it accepts.

Definition at line 103 of file Solvable.h.

## ◆ isKind() [3/3]

template<class TIterator>

bool zypp::sat::Solvable::isKind | ( | TIterator | begin,
|  | TIterator | end ) const
| inline

Definition at line 107 of file Solvable.h.

## ◆ name()

std::string zypp::sat::Solvable::name | ( |  | ) | const

The name (without any ResKind prefix).

Definition at line 330 of file Solvable.cc.

## ◆ edition()

Edition zypp::sat::Solvable::edition | ( |  | ) | const

The edition (version-release).

Definition at line 338 of file Solvable.cc.

## ◆ arch()

Arch zypp::sat::Solvable::arch | ( |  | ) | const

The architecture.

Definition at line 344 of file Solvable.cc.

## ◆ vendor()

IdString zypp::sat::Solvable::vendor | ( |  | ) | const

The vendor.

Definition at line 358 of file Solvable.cc.

## ◆ repository()

Repository zypp::sat::Solvable::repository | ( |  | ) | const

The Repository this Solvable belongs to.

Definition at line 364 of file Solvable.cc.

## ◆ repoInfo()

RepoInfo zypp::sat::Solvable::repoInfo | ( |  | ) | const

The repositories RepoInfo.

Definition at line 370 of file Solvable.cc.

## ◆ isSystem()

bool zypp::sat::Solvable::isSystem | ( |  | ) | const

Return whether this Solvable belongs to the system repo.

Note
  This includes the otherwise hidden systemSolvable.

Definition at line 374 of file Solvable.cc.

## ◆ onSystemByUser()

bool zypp::sat::Solvable::onSystemByUser | ( |  | ) | const

Whether this is known to be installed on behalf of a user request.

Note
  Returns `false` for non-system (uninstalled) solvables.

Definition at line 380 of file Solvable.cc.

## ◆ onSystemByAuto()

bool zypp::sat::Solvable::onSystemByAuto | ( |  | ) | const

Whether this is known to be automatically installed (as dependency of a user request package).

Note
  Returns `false` for non-system (uninstalled) solvables.

Definition at line 385 of file Solvable.cc.

## ◆ identIsAutoInstalled() [1/2]

bool zypp::sat::Solvable::identIsAutoInstalled | ( |  | ) | const
| inline

Whether an installed solvable with the same ident is flagged as AutoInstalled.

Definition at line 143 of file Solvable.h.

## ◆ identIsAutoInstalled() [2/2]

bool zypp::sat::Solvable::identIsAutoInstalled | ( | const IdString & | ident_r | ) |
| static

Definition at line 390 of file Solvable.cc.

## ◆ multiversionInstall()

bool zypp::sat::Solvable::multiversionInstall | ( |  | ) | const

Whether different versions of this package can be installed at the same time.

Per default `false`.

See also
  also ZConfig::multiversion.

Definition at line 431 of file Solvable.cc.

## ◆ isNeedreboot()

bool zypp::sat::Solvable::isNeedreboot | ( |  | ) | const

Whether this solvable triggers the reboot-needed hint if installed/updated.

Definition at line 395 of file Solvable.cc.

## ◆ isBlacklisted()

bool zypp::sat::Solvable::isBlacklisted | ( |  | ) | const

Whether this solvable is blacklisted (retracted,ptf,...).

Definition at line 402 of file Solvable.cc.

## ◆ isRetracted()

bool zypp::sat::Solvable::isRetracted | ( |  | ) | const

Whether this solvable is retracted (provides retractedToken).

Definition at line 405 of file Solvable.cc.

## ◆ isPtf()

bool zypp::sat::Solvable::isPtf | ( |  | ) | const

Whether this solvable belongs to a PTF (provides ptfMasterToken or ptfPackageToken).

Definition at line 415 of file Solvable.cc.

## ◆ isPtfMaster()

bool zypp::sat::Solvable::isPtfMaster | ( |  | ) | const

Subset of isPtf (provides ptfMasterToken).

Definition at line 418 of file Solvable.cc.

## ◆ isPtfPackage()

bool zypp::sat::Solvable::isPtfPackage | ( |  | ) | const

Subset of isPtf (provides ptfPackageToken).

Definition at line 424 of file Solvable.cc.

## ◆ buildtime()

Date zypp::sat::Solvable::buildtime | ( |  | ) | const

The items build time.

Definition at line 437 of file Solvable.cc.

## ◆ installtime()

Date zypp::sat::Solvable::installtime | ( |  | ) | const

The items install time (`false` if not installed).

Definition at line 443 of file Solvable.cc.

## ◆ asString()

std::string zypp::sat::Solvable::asString | ( |  | ) | const

String representation `"ident-edition.arch"` or `"noSolvable"`.

product:openSUSE-11.1.x86_64
autoyast2-2.16.19-0.1.src
noSolvable
zypp::sat::Solvable::noSolvable
static const Solvable noSolvable
Represents no Solvable.
Definition Solvable.h:80

Definition at line 449 of file Solvable.cc.

## ◆ asUserString()

std::string zypp::sat::Solvable::asUserString | ( |  | ) | const

String representation `"ident-edition.arch(repo)"` or `"noSolvable"`.

Definition at line 458 of file Solvable.cc.

## ◆ identical()

bool zypp::sat::Solvable::identical | ( | const Solvable & | rhs | ) | const

Test whether two Solvables have the same content.

Basically the same name, edition, arch, vendor and buildtime.

Definition at line 468 of file Solvable.cc.

## ◆ sameNVRA()

bool zypp::sat::Solvable::sameNVRA | ( | const Solvable & | rhs | ) | const
| inline

Test for same name-version-release.arch.

Definition at line 215 of file Solvable.h.

## ◆ dep_provides()

Capabilities zypp::sat::Solvable::dep_provides | ( |  | ) | const

Definition at line 485 of file Solvable.cc.

## ◆ dep_requires()

Capabilities zypp::sat::Solvable::dep_requires | ( |  | ) | const

Definition at line 490 of file Solvable.cc.

## ◆ dep_conflicts()

Capabilities zypp::sat::Solvable::dep_conflicts | ( |  | ) | const

Definition at line 495 of file Solvable.cc.

## ◆ dep_obsoletes()

Capabilities zypp::sat::Solvable::dep_obsoletes | ( |  | ) | const

Definition at line 500 of file Solvable.cc.

## ◆ dep_recommends()

Capabilities zypp::sat::Solvable::dep_recommends | ( |  | ) | const

Definition at line 505 of file Solvable.cc.

## ◆ dep_suggests()

Capabilities zypp::sat::Solvable::dep_suggests | ( |  | ) | const

Definition at line 510 of file Solvable.cc.

## ◆ dep_enhances()

Capabilities zypp::sat::Solvable::dep_enhances | ( |  | ) | const

Definition at line 515 of file Solvable.cc.

## ◆ dep_supplements()

Capabilities zypp::sat::Solvable::dep_supplements | ( |  | ) | const

Definition at line 520 of file Solvable.cc.

## ◆ dep_prerequires()

Capabilities zypp::sat::Solvable::dep_prerequires | ( |  | ) | const

Definition at line 525 of file Solvable.cc.

## ◆ provides()

Capabilities zypp::sat::Solvable::provides | ( |  | ) | const

## ◆ conflicts()

Capabilities zypp::sat::Solvable::conflicts | ( |  | ) | const

## ◆ obsoletes()

Capabilities zypp::sat::Solvable::obsoletes | ( |  | ) | const

## ◆ recommends()

Capabilities zypp::sat::Solvable::recommends | ( |  | ) | const

## ◆ suggests()

Capabilities zypp::sat::Solvable::suggests | ( |  | ) | const

## ◆ enhances()

Capabilities zypp::sat::Solvable::enhances | ( |  | ) | const

## ◆ supplements()

Capabilities zypp::sat::Solvable::supplements | ( |  | ) | const

## ◆ prerequires()

Capabilities zypp::sat::Solvable::prerequires | ( |  | ) | const

## ◆ dep()

Capabilities zypp::sat::Solvable::dep | ( | Dep | which_r | ) | const
| inline

Return Capabilities selected by Dep constant.

Definition at line 247 of file Solvable.h.

## ◆ operator[]()

Capabilities zypp::sat::Solvable::operator[] | ( | Dep | which_r | ) | const
| inline

Definition at line 264 of file Solvable.h.

## ◆ providesNamespace()

CapabilitySet zypp::sat::Solvable::providesNamespace | ( | const std::string & | namespace_r | ) | const

Return the namespaced provides `'namespace([value])[ op edition]'` of this Solvable.

Definition at line 551 of file Solvable.cc.

## ◆ valuesOfNamespace()

CapabilitySet zypp::sat::Solvable::valuesOfNamespace | ( | const std::string & | namespace_r | ) | const

Return `'value[ op edition]'` for namespaced provides `'namespace(value)[ op edition]'`.

Similar to providesNamespace, but the namespace is stripped from the dependencies. This is convenient if the namespace denotes packages that should be looked up. E.g. the `weakremover` namespace used in a products release package denotes the packages that were dropped from the distribution.

See also
  Product::droplist

Definition at line 565 of file Solvable.cc.

## ◆ matchesSolvable()

std::pair< bool, CapabilitySet > zypp::sat::Solvable::matchesSolvable | ( | const SolvAttr & | attr,
|  | const sat::Solvable & | solv ) const

Definition at line 583 of file Solvable.cc.

## ◆ supportsLocales()

bool zypp::sat::Solvable::supportsLocales | ( |  | ) | const

Whether this `Solvable` claims to support locales.

Definition at line 670 of file Solvable.cc.

## ◆ supportsLocale() [1/2]

bool zypp::sat::Solvable::supportsLocale | ( | const Locale & | locale_r | ) | const

Whether this `Solvable` supports a specific Locale.

Definition at line 676 of file Solvable.cc.

## ◆ supportsLocale() [2/2]

bool zypp::sat::Solvable::supportsLocale | ( | const LocaleSet & | locales_r | ) | const

Whether this `Solvable` supports at least one of the specified locales.

Definition at line 682 of file Solvable.cc.

## ◆ supportsRequestedLocales()

bool zypp::sat::Solvable::supportsRequestedLocales | ( |  | ) | const

Whether this `Solvable` supports at least one requested locale.

See also
  Pool::setRequestedLocales

Definition at line 690 of file Solvable.cc.

## ◆ getSupportedLocales() [1/2]

LocaleSet zypp::sat::Solvable::getSupportedLocales | ( |  | ) | const

Return the supported locales.

Definition at line 693 of file Solvable.cc.

## ◆ getSupportedLocales() [2/2]

void zypp::sat::Solvable::getSupportedLocales | ( | LocaleSet & | locales_r | ) | const
| inline

Definition at line 299 of file Solvable.h.

## ◆ cpeId()

CpeId zypp::sat::Solvable::cpeId | ( |  | ) | const

The solvables CpeId if available.

Definition at line 700 of file Solvable.cc.

## ◆ mediaNr()

unsigned zypp::sat::Solvable::mediaNr | ( |  | ) | const

Media number the solvable is located on (`0` if no media access required).

Definition at line 706 of file Solvable.cc.

## ◆ installSize()

ByteCount zypp::sat::Solvable::installSize | ( |  | ) | const

Installed (unpacked) size.

This is just a total number. Many objects provide even more detailed disk usage data. You can use DiskUsageCounter to find out how objects data are distributed across partitions/directories.

// Load directory set into ducounter
DiskUsageCounter ducounter( { "/", "/usr", "/var" } );
// see how noch space the packages use
for ( const PoolItem & pi : pool )
{
cout << pi << ducounter.disk_usage( pi ) << endl;
// I__s_(7)GeoIP-1.4.8-3.1.2.x86_64(@System) {
// dir:[/] [ bs: 0 B ts: 0 B us: 0 B (+-: 1.0 KiB)]
// dir:[/usr] [ bs: 0 B ts: 0 B us: 0 B (+-: 133.0 KiB)]
// dir:[/var] [ bs: 0 B ts: 0 B us: 0 B (+-: 1.1 MiB)]
// }
}
zypp::DiskUsageCounter
Compute disk space occupied by packages across partitions/directories.
Definition DiskUsageCounter.h:33
zypp::PoolItem
Combining sat::Solvable and ResStatus.
Definition PoolItem.h:51
zypp::pool
Definition ByIdent.h:24

See also
  DiskUsageCounter

Definition at line 719 of file Solvable.cc.

## ◆ downloadSize()

ByteCount zypp::sat::Solvable::downloadSize | ( |  | ) | const

Download size.

Definition at line 725 of file Solvable.cc.

## ◆ distribution()

std::string zypp::sat::Solvable::distribution | ( |  | ) | const

The distribution string.

Definition at line 731 of file Solvable.cc.

## ◆ summary()

std::string zypp::sat::Solvable::summary | ( | const Locale & | lang_r = Locale() | ) | const

Short (singleline) text describing the solvable (opt.

translated).

Definition at line 737 of file Solvable.cc.

## ◆ description()

std::string zypp::sat::Solvable::description | ( | const Locale & | lang_r = Locale() | ) | const

Long (multiline) text describing the solvable (opt.

translated).

Definition at line 743 of file Solvable.cc.

## ◆ insnotify()

std::string zypp::sat::Solvable::insnotify | ( | const Locale & | lang_r = Locale() | ) | const

UI hint text when selecting the solvable for install (opt.

translated).

Definition at line 749 of file Solvable.cc.

## ◆ delnotify()

std::string zypp::sat::Solvable::delnotify | ( | const Locale & | lang_r = Locale() | ) | const

UI hint text when selecting the solvable for uninstall (opt.

translated).

Definition at line 755 of file Solvable.cc.

## ◆ licenseToConfirm()

std::string zypp::sat::Solvable::licenseToConfirm | ( | const Locale & | lang_r = Locale() | ) | const

License or agreement to accept before installing the solvable (opt.

translated).

Definition at line 761 of file Solvable.cc.

## ◆ needToAcceptLicense()

bool zypp::sat::Solvable::needToAcceptLicense | ( |  | ) | const

`True` except for well known exceptions (i.e show license but no need to accept it).

Definition at line 778 of file Solvable.cc.

## ◆ lookupStrAttribute() [1/2]

std::string zypp::sat::Solvable::lookupStrAttribute | ( | const SolvAttr & | attr | ) | const

returns the string attribute value for attr or an empty string if it does not exists.

Definition at line 131 of file Solvable.cc.

## ◆ lookupStrAttribute() [2/2]

std::string zypp::sat::Solvable::lookupStrAttribute | ( | const SolvAttr & | attr,
|  | const Locale & | lang_r ) const

Definition at line 138 of file Solvable.cc.

## ◆ lookupNumAttribute() [1/2]

unsigned long long zypp::sat::Solvable::lookupNumAttribute | ( | const SolvAttr & | attr | ) | const

returns the numeric attribute value for attr or 0 if it does not exists.

Definition at line 159 of file Solvable.cc.

## ◆ lookupNumAttribute() [2/2]

unsigned long long zypp::sat::Solvable::lookupNumAttribute | ( | const SolvAttr & | attr,
|  | unsigned long long | notfound_r ) const

Definition at line 165 of file Solvable.cc.

## ◆ lookupBoolAttribute()

bool zypp::sat::Solvable::lookupBoolAttribute | ( | const SolvAttr & | attr | ) | const

returns the boolean attribute value for attr or `false` if it does not exists.

Definition at line 171 of file Solvable.cc.

## ◆ lookupIdAttribute()

detail::IdType zypp::sat::Solvable::lookupIdAttribute | ( | const SolvAttr & | attr | ) | const

returns the id attribute value for attr or detail::noId if it does not exists.

Definition at line 177 of file Solvable.cc.

## ◆ lookupCheckSumAttribute()

CheckSum zypp::sat::Solvable::lookupCheckSumAttribute | ( | const SolvAttr & | attr | ) | const

returns the CheckSum attribute value for attr or an empty CheckSum if ir does not exist.

Definition at line 183 of file Solvable.cc.

## ◆ lookupLocation()

OnMediaLocation zypp::sat::Solvable::lookupLocation | ( |  | ) | const

returns OnMediaLocation data: This is everything we need to download e.g.

an rpm (path, checksum, downloadsize, etc.).

Definition at line 225 of file Solvable.cc.

## ◆ nextInPool()

Solvable zypp::sat::Solvable::nextInPool | ( |  | ) | const

Return next Solvable in Pool (or noSolvable).

Definition at line 114 of file Solvable.cc.

## ◆ nextInRepo()

Solvable zypp::sat::Solvable::nextInRepo | ( |  | ) | const

Return next Solvable in Repo (or noSolvable).

Definition at line 117 of file Solvable.cc.

## ◆ get()

detail::CSolvable * zypp::sat::Solvable::get | ( |  | ) | const

Expert backdoor.

Definition at line 107 of file Solvable.cc.

## ◆ id()

IdType zypp::sat::Solvable::id | ( |  | ) | const
| inline

Expert backdoor.

Definition at line 445 of file Solvable.h.

## Friends And Related Symbol Documentation

## ◆ operator<<()

std::ostream & operator<< | ( | std::ostream & | str,
|  | const Solvable & | obj )
| related

Stream output.

Definition at line 794 of file Solvable.cc.

## ◆ dumpOn()

std::ostream & dumpOn | ( | std::ostream & | str,
|  | const Solvable & | obj )
| related

More verbose stream output including dependencies.

Definition at line 805 of file Solvable.cc.

## ◆ dumpAsXmlOn()

std::ostream & dumpAsXmlOn | ( | std::ostream & | str,
|  | const Solvable & | obj )
| related

XML output.

Definition at line 825 of file Solvable.cc.

## ◆ operator==()

bool operator== | ( | const Solvable & | lhs,
|  | const Solvable & | rhs )
| related

Definition at line 462 of file Solvable.h.

## ◆ operator!=()

bool operator!= | ( | const Solvable & | lhs,
|  | const Solvable & | rhs )
| related

Definition at line 466 of file Solvable.h.

## ◆ operator<()

bool operator< | ( | const Solvable & | lhs,
|  | const Solvable & | rhs )
| related

Definition at line 470 of file Solvable.h.

## ◆ isKind()

template<class TRes>

bool isKind | ( | const Solvable & | solvable_r | ) |
| related

Test whether a Solvable is of a certain Kind.

Definition at line 475 of file Solvable.h.

## ◆ identical()

bool identical | ( | const Solvable & | lhs,
|  | const Solvable & | rhs )
| related

Test for same content.

Definition at line 479 of file Solvable.h.

## ◆ sameNVRA()

bool sameNVRA | ( | const Solvable & | lhs,
|  | const Solvable & | rhs )
| related

Test for same name version release and arch.

Definition at line 483 of file Solvable.h.

## ◆ compareByN()

int compareByN | ( | const Solvable & | lhs,
|  | const Solvable & | rhs )
| related

Compare according to kind and name.

Definition at line 488 of file Solvable.h.

## ◆ compareByNVR()

int compareByNVR | ( | const Solvable & | lhs,
|  | const Solvable & | rhs )
| related

Compare according to kind, name and edition.

Definition at line 500 of file Solvable.h.

## ◆ compareByNVRA()

int compareByNVRA | ( | const Solvable & | lhs,
|  | const Solvable & | rhs )
| related

Compare according to kind, name, edition and arch.

Definition at line 509 of file Solvable.h.

## Member Data Documentation

## ◆ retractedToken

const IdString zypp::sat::Solvable::retractedToken { "retracted-patch-package()" }
| static

Indicator provides `retracted-patch-package()`

Definition at line 58 of file Solvable.h.

## ◆ ptfMasterToken

const IdString zypp::sat::Solvable::ptfMasterToken { "ptf()" }
| static

Indicator provides `ptf()`

Definition at line 59 of file Solvable.h.

## ◆ ptfPackageToken

const IdString zypp::sat::Solvable::ptfPackageToken { "ptf-package()" }
| static

Indicator provides `ptf-package()`

Definition at line 60 of file Solvable.h.

## ◆ noSolvable

const Solvable zypp::sat::Solvable::noSolvable
| static

Represents no Solvable.

Definition at line 80 of file Solvable.h.

## ◆ ZYPP_DEPRECATED

Capabilities const zypp::sat::Solvable::ZYPP_DEPRECATED

Definition at line 236 of file Solvable.h.

## ◆ _id

IdType zypp::sat::Solvable::_id
| private

Definition at line 448 of file Solvable.h.

The documentation for this class was generated from the following files:

- zypp/sat/Solvable.h
- zypp/sat/Solvable.cc